Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| OptaPlanner distribution 6.0.1.Final
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.optaplanner.core.api.score.buildin.bendable
Class BendableScore

    java.lang.Object
      org.optaplanner.core.api.score.AbstractScore<BendableScore>
          org.optaplanner.core.api.score.buildin.bendable.BendableScore

All Implemented Interfaces:
  Serializable, Comparable<BendableScore>, FeasibilityScore<BendableScore>, Score<BendableScore>

    public final class BendableScore

extends AbstractScore<BendableScore>
implements FeasibilityScore<BendableScore>

This `Score` is based on n levels of int constraints. The number of levels is bendable at configuration time.

This class is immutable.

The `getHardLevelCount()` and `getSoftLevelCount()` must be the same as in the `BendableScoreDefinition` used.

See Also:
  `Score`, Serialized Form

Constructor Summary
`protected` | `BendableScore(int[] hardScores, int[] softScores)`

Method Summary
`BendableScore` | `add(BendableScore augment)` Returns a Score whose value is (this + augment).
`int` | `compareTo(BendableScore other)`
`BendableScore` | `divide(double divisor)` Returns a Score whose value is (this / divisor).
`boolean` | `equals(Object o)`
`int` | `getHardLevelCount()`
`int` | `getHardScore(int index)`
`int` | `getSoftLevelCount()`
`int` | `getSoftScore(int index)`
`int` | `hashCode()`
`boolean` | `isFeasible()` A `Solution` is feasible if it has no broken hard constraints.
`BendableScore` | `multiply(double multiplicand)` Returns a Score whose value is (this * multiplicand).
`static BendableScore` | `parseScore(int hardLevelCount, int softLevelCount, String scoreString)`
`BendableScore` | `power(double exponent)` Returns a Score whose value is (this ^ exponent).
`BendableScore` | `subtract(BendableScore subtrahend)` Returns a Score whose value is (this - subtrahend).
`Number[]` | `toLevelNumbers()` Returns an array of doubles representing the Score.
`String` | `toString()`
`void` | `validateCompatible(BendableScore other)`
`static BendableScore` | `valueOf(int[] hardScores, int[] softScores)` Creates a new `BendableScore`.

Methods inherited from class org.optaplanner.core.api.score.AbstractScore
`buildScorePattern, buildScorePattern, parseLevelStrings, parseLevelStrings`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### BendableScore

    protected BendableScore(int[] hardScores,
                            int[] softScores)

Method Detail

### parseScore

    public static BendableScore parseScore(int hardLevelCount,
                                           int softLevelCount,
                                           String scoreString)

### valueOf

    public static BendableScore valueOf(int[] hardScores,
                                        int[] softScores)

  Creates a new `BendableScore`.

  Parameters:
    `hardScores` - never null, never change that array afterwards: it must be immutable
    `softScores` - never null, never change that array afterwards: it must be immutable
  Returns:
    never null

### getHardLevelCount

    public int getHardLevelCount()

### getHardScore

    public int getHardScore(int index)

  Parameters:
    `index` - 0 <= index < hardLevelCount
  Returns:
    higher is better

### getSoftLevelCount

    public int getSoftLevelCount()

### getSoftScore

    public int getSoftScore(int index)

  Parameters:
    `index` - 0 <= index < softLevelCount
  Returns:
    higher is better

### isFeasible

    public boolean isFeasible()

  Description copied from interface: `FeasibilityScore`
  A `Solution` is feasible if it has no broken hard constraints.

  Specified by:
    `isFeasible` in interface `FeasibilityScore<BendableScore>`
  Returns:
    true if the hard score(s) is 0 or higher

### add

    public BendableScore add(BendableScore augment)

  Description copied from interface: `Score`
  Returns a Score whose value is (this + augment).

  Specified by:
    `add` in interface `Score<BendableScore>`
  Parameters:
    `augment` - value to be added to this Score
  Returns:
    this + augment

### subtract

    public BendableScore subtract(BendableScore subtrahend)

  Description copied from interface: `Score`
  Returns a Score whose value is (this - subtrahend).

  Specified by:
    `subtract` in interface `Score<BendableScore>`
  Parameters:
    `subtrahend` - value to be subtracted from this Score
  Returns:
    this - subtrahend, rounded as necessary

### multiply

    public BendableScore multiply(double multiplicand)

  Description copied from interface: `Score`
  Returns a Score whose value is (this * multiplicand). When rounding is needed, it should be floored (as defined by `Math.floor(double)`.

  /> If the implementation has a scale/precision, then the unspecified scale/precision of the double multiplicand should have no impact on the returned scale/precision.

  Specified by:
    `multiply` in interface `Score<BendableScore>`
  Parameters:
    `multiplicand` - value to be multiplied by this Score.
  Returns:
    this * multiplicand

### divide

    public BendableScore divide(double divisor)

  Description copied from interface: `Score`
  Returns a Score whose value is (this / divisor). When rounding is needed, it should be floored (as defined by `Math.floor(double)`.

  /> If the implementation has a scale/precision, then the unspecified scale/precision of the double divisor should have no impact on the returned scale/precision.

  Specified by:
    `divide` in interface `Score<BendableScore>`
  Parameters:
    `divisor` - value by which this Score is to be divided
  Returns:
    this / divisor

### power

    public BendableScore power(double exponent)

  Description copied from interface: `Score`
  Returns a Score whose value is (this ^ exponent). When rounding is needed, it should be floored (as defined by `Math.floor(double)`.

  /> If the implementation has a scale/precision, then the unspecified scale/precision of the double exponent should have no impact on the returned scale/precision.

  Specified by:
    `power` in interface `Score<BendableScore>`
  Parameters:
    `exponent` - value by which this Score is to be powered
  Returns:
    this ^ exponent

### toLevelNumbers

    public Number[] toLevelNumbers()

  Description copied from interface: `Score`
  Returns an array of doubles representing the Score. Each double represents 1 score level. A greater score level uses a lower array index than a lesser score level.

  When rounding is needed, each rounding should be floored (as defined by `Math.floor(double)`. The length of the returned array must be stable for a specific `Score` implementation.

  For example: -0hard/-7soft returns new double{-0.0, -7.0}

  Specified by:
    `toLevelNumbers` in interface `Score<BendableScore>`
  Returns:
    never null

### equals

    public boolean equals(Object o)

  Overrides:
    `equals` in class `Object`

### hashCode

    public int hashCode()

  Overrides:
    `hashCode` in class `Object`

### compareTo

    public int compareTo(BendableScore other)

  Specified by:
    `compareTo` in interface `Comparable<BendableScore>`

### toString

    public String toString()

  Overrides:
    `toString` in class `Object`

### validateCompatible

    public void validateCompatible(BendableScore other)

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| OptaPlanner distribution 6.0.1.Final
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2006-2013 JBoss by Red Hat. All Rights Reserved.